import pyddl
import os
import sys
import numpy as np

n = 100

pyddl.init(os.environ['DDL_OPTIONS'])

initial_values = [x for x in range(n)]

arr = np.array(initial_values, dtype=np.float32)

pyddl.allreduce(arr, n, pyddl.DDL_TYPE_FLOAT, pyddl.DDL_OP_SUM)

# Verify that the allreduce produced the correct result
result = np.array_equal(pyddl.size() * np.array(initial_values, dtype=np.float32), arr)

pyddl.finalize()

if result:
    sys.exit(0)
else:
    sys.exit(1)

